// 
//  DotNetNuke - http://www.dotnetnuke.com
//  Copyright (c) 2002-2007
//  by DotNetNuke Corporation
// 
//  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
//  documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
//  the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
//  to permit persons to whom the Software is furnished to do so, subject to the following conditions:
// 
//  The above copyright notice and this permission notice shall be included in all copies or substantial portions 
//  of the Software.
// 
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
//  TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
//  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
//  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
//  DEALINGS IN THE SOFTWARE.
// 

using System.Web;
using System.Web.Services;
using System.Xml;
using System.Web.Services.Protocols;
using System.Web.Script.Services;

using System.Data;
using System.Configuration;
using System;
using System.EnterpriseServices;
using System.Drawing;
using System.ServiceModel;
using System.Runtime.Serialization;
using System.Web.Mobile;
using System.IdentityModel;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using DotNetNuke.Entities.Users;

namespace DotNetNuke.Modules.IWebXAML_C
{

    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ScriptService()]
    public class WebService : System.Web.Services.WebService
    {

        [WebMethod(Description = "GetSilverlightUser")]
        [ScriptMethod()]
        public string GetUser(int PortalID, string ModuleId, int UserID, string Password)
        {

            IWebXAMLAuthendicationHeader objIWebXAMLAuthendicationHeader = new IWebXAMLAuthendicationHeader();
            objIWebXAMLAuthendicationHeader.PortalID = PortalID;
            objIWebXAMLAuthendicationHeader.UserID = UserID;
            objIWebXAMLAuthendicationHeader.Password = Password;
            objIWebXAMLAuthendicationHeader.ModuleId = Convert.ToInt32(ModuleId);

            IWebXAMLAuthendication objIWebXAMLAuthendication = new IWebXAMLAuthendication(objIWebXAMLAuthendicationHeader);
            if (!(objIWebXAMLAuthendication.IsUserValid()))
            {
                return "Hello World!";
            }
            else
            {
                UserInfo objUser = objIWebXAMLAuthendication.GetUserInfo();
                return "Hello " + objUser.DisplayName + "!";
            }

        }

    }

}
